<div class="header">
  <mat-toolbar color="primary">
    <mat-toolbar-row>
      <!-- Log out btn -->
      <a (click)="logOut()" class="mat-focus-indicator docs-button mat-button mat-button-base">
        <span class="mat-button-wrapper">
          <mat-icon class="header-button-img" matTooltip="Logout">power_settings_new</mat-icon>
          <span>Log Out</span>
        </span>
        <div matripple="" class="mat-ripple mat-button-ripple"></div>
        <div class="mat-button-focus-overlay"></div>
      </a>

      <!-- Add user btn -->
      <a (click)="addUser()" class="mat-focus-indicator docs-button mat-button mat-button-base">
        <span class="mat-button-wrapper">
          <mat-icon class="header-button-img" matTooltip="Add User">perm_identity</mat-icon>
          <span>Add User</span>
        </span>
        <div matripple="" class="mat-ripple mat-button-ripple"></div>
        <div class="mat-button-focus-overlay"></div>
      </a>

      <span class="header-spacer"></span>

      <!-- Filter for table -->
      <mat-form-field>
        <mat-icon matSuffix>search</mat-icon>
        <mat-label>Search user</mat-label>
        <input matInput (keyup)="applyFilter($event)">
      </mat-form-field>

    </mat-toolbar-row>
  </mat-toolbar>
</div>
<div class="wrapper">
  <!-- Main table -->
  <table mat-table [dataSource]="dataSource" multiTemplateDataRows class="mat-elevation-z8">
    <ng-container matColumnDef="{{column}}" *ngFor="let column of mainColumnsToDisplay">
      <div *ngIf="column == 'action'; else otherContent">
        <th mat-header-cell *matHeaderCellDef>Action</th>
        <td mat-cell *matCellDef="let element">
          <button mat-icon-button [matMenuTriggerFor]="menu" (click)="actionChange($event)">
            <mat-icon>more_vert</mat-icon>
          </button>
          <mat-menu #menu="matMenu">
            <button mat-menu-item (click)="editUser(element)">
              <mat-icon>edit</mat-icon><span>Edit</span>
            </button>
            <button mat-menu-item (click)="removeUser(element)">
              <mat-icon>delete_forever</mat-icon><span>Remove</span>
            </button>
          </mat-menu>
        </td>
      </div>
      <ng-template #otherContent>
          <th mat-header-cell *matHeaderCellDef> {{lodash.startCase(column)}} </th>
          <td mat-cell *matCellDef="let element"> {{element[column]}} </td>
      </ng-template>
    </ng-container>

    <!-- Expanded Content Column - The detail row is made up of this one column that spans across all columns -->
    <ng-container matColumnDef="expandedDetail">
      <td mat-cell *matCellDef="let element" [attr.colspan]="mainColumnsToDisplay.length">
        <div class="example-element-detail" [@detailExpand]="element == expandedElement ? 'expanded' : 'collapsed'">
          <div class="example-element-diagram">
            <!-- <div class="example-element-position"> {{element.position}} </div> -->
            <div class="example-element-short-name">
              {{lodash.capitalize(element.firstName).substring(0, 1)}}{{lodash.capitalize(element.lastName).substring(0, 1)}}
            </div>
          </div>
          <div class="example-element-diagram custom"> 
            <mat-list>
              <mat-list-item>
                <mat-icon mat-list-icon>picture_in_picture</mat-icon>
                <h4 mat-line><span style="font-weight: bold;">Name</span>:</h4>
                <p mat-line> {{element.firstName}} {{element.lastName}} </p>
              </mat-list-item>
              <mat-list-item>
                <mat-icon mat-list-icon>date_range</mat-icon>
                <h4 mat-line><span style="font-weight: bold;">Birthday</span>:</h4>
                <p mat-line> {{element.dob | date:'dd/MM/yyyy'}} </p>
              </mat-list-item>
            </mat-list>
          </div>
          <div class="example-element-diagram custom"> 
            <mat-list>
              <mat-list-item>
                <mat-icon mat-list-icon>create</mat-icon>
                <h4 mat-line><span style="font-weight: bold;">Created by</span>: {{element.createdBy ? element.createdBy : 'N/A'}}</h4>
                <p mat-line> {{element.createdAt | date:'dd/MM/yyyy HH:mm'}} </p>
              </mat-list-item>
              <mat-list-item>
                <mat-icon mat-list-icon>update</mat-icon>
                <h4 mat-line><span style="font-weight: bold;">Updated by</span>: {{element.updatedBy ? element.updatedBy : 'N/A'}}</h4>
                <p mat-line> {{element.updatedAt | date:'dd/MM/yyyy HH:mm'}} </p>
              </mat-list-item>
            </mat-list>
          </div>
          <div class="example-element-diagram custom"> 
            <mat-list>
              <mat-list-item>
                <mat-icon mat-list-icon>description</mat-icon>
                <h4 mat-line><span style="font-weight: bold;">Description</span>: </h4>
                <p mat-line>  {{element.desc ? element.desc : 'N/A'}} </p>
              </mat-list-item>
            </mat-list>
          </div>
        </div>
      </td>
    </ng-container>

    <tr mat-header-row *matHeaderRowDef="mainColumnsToDisplay"></tr>
    <tr mat-row *matRowDef="let element; columns: mainColumnsToDisplay;" class="example-element-row"
      [class.example-expanded-row]="expandedElement === element"
      (click)="expandedElement = expandedElement === element ? null : element">
    </tr>
    <tr mat-row *matRowDef="let row; columns: ['expandedDetail']" class="example-detail-row"></tr>

  </table>
</div>